/* Example for data chacking*/
#include "CifFile.h"
#include "DicFile.h"
#include "DdlFile.h"
#include "CifParserBase.h"
#include "DDLParserBase.h"
#include "DICParserBase.h"
#include <iostream>
#include <time.h>


#define FALSE 0
#define NS 10
int main(int argc, char *argv[]) {
  string diags;
  ISTable *ddlformat;
  DdlFile * ddl = NULL;
  ISTable *dicformat;
  DicFile * dic = NULL;
  CifFile * fobjR = NULL;
  time_t start,end;
  FILE * fpN;
  string cifFile;

  CifFileReadDef readDef;
  CifParser* cifParserR = NULL;
  DICParser* dicParserR = NULL;
  DDLParser* ddlParserR = NULL;

  if (argc < 2) {
    cerr << argv[0] << ":  usage = <ciffile> " << endl;
    exit(1);
  }

  cifFile = argv[1];          

   time(&start);
  ddl = new DdlFile(VIRTUAL_MODE, String::Empty, true);
  ddlformat = new ISTable("ddlformat");
//  ddl->Read("./ndb_ddl",ddlformat, diags);

  ddlParserR = new DDLParser(ddl, ddlformat, ddl->GetVerbose());

  ddlParserR->Parse("./ddl-mm", diags);

  delete(ddlParserR);

  cout<<"diags = ";
  if (!(diags.empty()))
  {
    cout<<diags;
  }
  cout<<endl;
  time(&end);
  cout<<"second(s)"<<difftime(end,start)<<endl;

  time(&start);
  if((fpN=fopen("./dictionary.sdb","r")) == NULL) {
    cout<<"First time"<<endl;
    dicformat = new ISTable("dicformat");
    dic = new DicFile(CREATE_MODE, "./dictionary.sdb");
    //  dic->Read("./ndb_dictionary.dic",ddl , dicformat, diags);

    dicParserR = new DICParser(dic, ddl, dicformat, dic->GetVerbose());

    dicParserR->Parse("./dictionary.dic", diags);

    delete(dicParserR);

  }
  else {
    fclose(fpN);
    dic = new DicFile(READ_MODE, "./dictionary.sdb");
  }

  time(&end);
  cout<<"second(s)"<<difftime(end,start)<<endl;
  cout<<"diags = ";
  if (!(diags.empty()))
  {
    cout<<diags;
  }
  cout<<endl;

  dic->Compress(ddl);

  time(&start);
  fobjR = new CifFile(VIRTUAL_MODE, String::Empty, true);
  cout<<cifFile<<endl;

  cifParserR = new CifParser(fobjR, fobjR->GetVerbose(), readDef);

  cifParserR->Parse(cifFile, diags);

  delete(cifParserR);

  time(&end);
  cout<<"second(s)"<<difftime(end,start)<<endl;
  cout<<"============================="<<endl;
  time(&start);
  fobjR->DataChecking(*dic);

  time(&end);
  cout<<"second(s)"<<difftime(end,start)<<endl;
  ddl->Close();
  if (ddl) delete ddl;
  dic->Close();
  if (dic) delete dic;
  fobjR->Close();
  if (fobjR) delete fobjR;
exit(0);
}
